# Juju prometheus2 charm

This charm provides the Prometheus monitoring system from http://prometheus.io/.

It supports version 2.0 and later. If you want to deploy prometheus 1.x please
use cs:prometheus charm.

Optionally the charm will install the [Prometheus Registration daemon](https://launchpad.net/prometheus-registration)
alongside Prometheus to aid in the registration of targets.

The charm can be related to the following charms to extend functionality:

* grafana
* prometheus-alertmanager
* prometheus-pushgateway
* prometheus-snmp-exporter
* prometheus-blackbox-exporter
* telegraf
* mtail

## Configuration

The charm is designed to work out of the box without need to set any
configuration options. Please refer to config.yaml for detailed help on
support settings. Below is a list of the most common options:

 * **daemon-args** - add extra CLI arguments, for example `--storage.tsdb.retention=21d`
 * **scrape-jobs** - allows for custom scrape jobs to be configured
 * **snap_proxy** - web proxy address to use when accessing the snap store
 * **external_url**
 * **scrape-interval**
 * **evaluation-interval**
 * **remote-read/remote-write** - configure read/write to remote datastore endpoints

## Juju storage support

The charm supports juju storage (requires juju 1.25 or later).
For example to deploy with local filesystem run:

    juju deploy local:trusty/prometheus2 --storage metrics-filesystem=rootfs prometheus2

## Juju resources support

The charm support juju resources, which is handy in offline deployments. Prefetch the snaps:

    snap download --channel=stable core
    snap download --channel=2/stable prometheus

Provide downloaded snaps as resources to the application:

    juju deploy cs:prometheus2 --resource core=core_6818.snap --resource prometheus=prometheus_20.snap
